/* BegSys.java - pomocna trida pro praci s mnozinami.
 *
 * Michal Beran, berny@students.zcu.cz
 * 4.1.2001  
 */

/** Trida Begsys obsahuje preddefinovane sablony mnozin
  * pouzivane prekladacem jazyka PL/0.
  */

package pl0prog;  
  
public class BegSys {

	/** Mnozina symbolu pro prikaz (statement) */
	public static final SetSym StatBegSys = new SetSym();
	/** Mnozina symbolu pro deklaraci */
	public static final SetSym DeclBegSys = new SetSym();
	/** Mnozina symbolu pro faktor */
	public static final SetSym FacBegSys = new SetSym();
		
	static {
	
		StatBegSys.set(SetSym.BEGINSYM);
		StatBegSys.set(SetSym.CALLSYM);
		StatBegSys.set(SetSym.IFSYM);
		StatBegSys.set(SetSym.WHILESYM);
	  	DeclBegSys.set(SetSym.CONSTSYM);
	  	DeclBegSys.set(SetSym.VARSYM);		
	  	DeclBegSys.set(SetSym.PROCSYM);				
		FacBegSys.set(SetSym.IDENT);				
		FacBegSys.set(SetSym.NUMBER);						
		FacBegSys.set(SetSym.LPAREN);
	}
}

