/* Locatable.java - popisuje adresovatelne objekty.
 *
 * Michal Beran, berny@students.zcu.cz
 * 4.1.2001
 */
package pl0prog; 

/* Rodicovska abstraktni trida pro identifikatory,
   jez jsou specifikovany adresou a urovni zanoreni */
public abstract class Locatable extends Identifier {
	/** Adresa */
	int address;
	/** Uroven zanoreni */
	int level;

	/** Vraci aktualni adresu 
	  * @return vracena adresa 
	  */
	public int getAddress() {return address;};
	/** Nastav adresu.
	  * @param adress pozadovana adresa,
	  */
	public void setAddress(int adr) {address = adr;};
	/** Vraci aktualni uroven zanoreni,
	  * @return vracena uroven zanoreni.
	  */
	public int getLevel() {return level;};
	/** Nastav uroven zanoreni.
	  * @param vracena uroven zanoreni.
	  */
	public void setLevel(int l) {level = l;};

}
